int touchCount = 10;
char color = 'w';

int read_high;
int read_low;
int diff;
int total;
int N_samples = 100;

#include <SoftwareSerial.h>
SoftwareSerial SerialBt(2, 3);
char fromApp = 'd';

#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
#endif

#define PIN A4
#define NUM_LEDS 16
Adafruit_NeoPixel strip = Adafruit_NeoPixel(NUM_LEDS, PIN, NEO_GRBW + NEO_KHZ800);


void setup()
{
  pinMode(4,OUTPUT);
  Serial.begin(9600);
  SerialBt.begin(9600);
//    strip.setBrightness(BRIGHTNESS);
  strip.begin();
  strip.show(); // Initialize all pixels to 'off'


  strip.setBrightness(10);
  colorWipe(strip.Color(0, 0, 0, 255), 50); // White

}

void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
    strip.setPixelColor(i, c);
    strip.show();
    delay(wait);
  }
}

void loop()
{
   total = 0;
   for (int i = 0; i < N_samples; i++){
     digitalWrite(4,HIGH);
     read_high = analogRead(A0);
     digitalWrite(4,LOW);
     read_low = analogRead(A0);
     diff = read_high - read_low;
     total += diff;
   }
    Serial.println(total);
    delay(20);


 //CAPACITATIVE TOUCH TRIGGER
  if (total < 5000) {
      if (touchCount < 120) {
      touchCount = touchCount + 30;
      strip.setBrightness(touchCount);
//      Serial.print(touchCount);
//      Serial.println("\t");
      }
      
      else {
      touchCount = 0;
      strip.setBrightness(touchCount);
//    Serial.print(touchCount);
//    Serial.println("\t");
      }

      if (color == 'r') {
      colorWipe(strip.Color(255, 0, 0), 50); // Red
      }

      if (color == 'g') {
      colorWipe(strip.Color(0, 255, 0), 50); // Green
       }

      if (color == 'b') {
      colorWipe(strip.Color(0, 0, 255), 50); // Blue
      }

      if (color == 'y') {
      colorWipe(strip.Color(255, 135, 0), 50); // Orange
      }

      if (color == 'p') {
      colorWipe(strip.Color(128, 0, 128), 50); // Purple
      }

      if (color == 'o') {
      colorWipe(strip.Color(255, 100, 0), 50); // Yellow
      }

      if (color == 'w') {
      colorWipe(strip.Color(0, 0, 0, 255), 50); // White
      }
   
   }


 //BLUETOOTH TRIGGER
   if (SerialBt.available()) {
      
        fromApp = SerialBt.read();

        if (fromApp == 'r') {
          color = fromApp;
          strip.setBrightness(touchCount);
          colorWipe(strip.Color(255, 0, 0), 50); // Red
          delay(10);  
          
        }


        if (fromApp == 'g') {
          color = fromApp;
          strip.setBrightness(touchCount);
          colorWipe(strip.Color(0, 255, 0), 50); // Green
          delay(10);  
        }

        if (fromApp == 'b') {
          color = fromApp;
          strip.setBrightness(touchCount);
          colorWipe(strip.Color(0, 0, 255), 50); // Blue
          delay(10);  
        }

        if (fromApp == 'y') {
          color = fromApp;
          strip.setBrightness(touchCount);
            colorWipe(strip.Color(255, 135, 0), 50);
          delay(10);  
        }

        if (fromApp == 'p') {
          color = fromApp;
          strip.setBrightness(touchCount);
          colorWipe(strip.Color(128, 0, 128), 50); // Purple
          delay(10);  
        }

        if (fromApp == 'o') {
          color = fromApp;
          strip.setBrightness(touchCount);
          colorWipe(strip.Color(255, 100, 0), 50); // Yellow
          delay(10);  
        }

     
  
        if (fromApp == 'c') {
          color = 'w';
          strip.setBrightness(touchCount);
          colorWipe(strip.Color(0, 0, 0, 255), 50); // White
          delay(10);  
        }

          if (fromApp == 'd') {
          color = 'w';
          strip.setBrightness(touchCount);
          colorWipe(strip.Color(0, 0, 0, 255), 50); // White
          delay(10);  
        }


  }

  
//   if (fromApp == 'd') {
////              int TOTAL_LEDS = 16;
//          float MaximumBrightness = 255;
//          float SpeedFactor = 0.02; // I don't actually know what would look good
//          float StepDelay = 5; // ms for a step delay on the lights
//          
//          // Make the lights breathe
//          for (int i = 0; i < 65535; i++) {
//          // Intensity will go from 10 - MaximumBrightness in a "breathing" manner
//          float intensity = MaximumBrightness /2.0 * (1.0 + sin(SpeedFactor * i));
//          strip.setBrightness(intensity);
//          // Now set every LED to that color
//          for (int ledNumber=0; ledNumber<16; ledNumber++) {
//          strip.setPixelColor(ledNumber, 0, 0, 0, 255);
//          }
//          
//          strip.show();
//          //Wait a bit before continuing to breathe
//          delay(StepDelay);
//          
//          }
//   }

}
